<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmDebug: kmDebug Library</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">kmDebug
   </div>
   <div id="projectbrief">kmDebug library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('md__c_1__d_drive__development__a_v_r__workspace__atmel_studio7_km_avr_tests_km_debug_test_km_debug__r_e_a_d_m_e.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">kmDebug Library </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This repository contains the kmDebug library, a debug and troubleshooting library for AVR MCUs.</p>
<h2>Overview</h2>
<p>The <code>kmDebug</code> library provides functions to facilitate debugging and troubleshooting on AVR microcontrollers.</p>
<h3>Features</h3>
<ul>
<li>Initialization of debug pins</li>
<li>Toggling debug pins</li>
<li>Turning debug pins on and off</li>
<li>Customizable debug pin configurations</li>
</ul>
<h2>Installation</h2>
<p>To use the <code>kmDebug</code> library in your AVR MCU project, simply include the necessary header files and source files in your project directory.</p>
<p>Getting this library and adding it to own project: </p><div class="fragment"><div class="line">// To add this module to own project as submodule - enter the main directory of the source code and use git command: </div><div class="line">git submodule add git@gitlab.poland:avr/kmAvrLibs/kmDebug.git kmDebug</div><div class="line">// After cloning own application from git repository use following additional git command to get correct revision of submodule:</div><div class="line">git submodule update --init </div></div><!-- fragment --> <h2>Configuration</h2>
<p>The default configuration options for <code>kmDebug</code> can be overridden in the main config file <code><a class="el" href="km_debug_default_config_8h.html" title="Default configuration options that can be overridden in main config file kmDebugDefaultConfig....">kmDebugDefaultConfig.h</a></code>. Below are some of the configurable options:</p>
<ul>
<li>Inverted output logic</li>
<li>Definition of MCU's direction register and port register</li>
<li>Definition of debug pins</li>
</ul>
<h2>Usage</h2>
<p>See kmDebug Test Application:</p><ul>
<li><a href="https://gitlab.com/c-mos/kmAvrTests/kmDebugTest">https://gitlab.com/c-mos/kmAvrTests/kmDebugTest</a></li>
</ul>
<div class="fragment"><div class="line"><span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;stdio.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;stdbool.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;util/delay.h&gt;</span></div><div class="line"></div><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="km_debug_8h.html">kmDebug/kmDebug.h</a>&quot;</span></div><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="km_debug_default_config_8h.html">kmDebug/kmDebugDefaultConfig.h</a>&quot;</span></div><div class="line"></div><div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div><div class="line">    <a class="code" href="km_debug_8h.html#a2e3f24e3758b6264b61cf4eff527a87f">dbPullUpAllPorts</a>();</div><div class="line">    <a class="code" href="km_debug_8h.html#a2d9ae3859d0da45b5a0218aab0387df2">dbInit</a>();</div><div class="line">    <a class="code" href="km_debug_8h.html#a03904c051c3250069b3f565a9c6aee16">dbOff</a>(<a class="code" href="km_debug_8h.html#aa75c08c034edbf8e7d2ab7f4368ba1f3a68e15f535d372cae08798ca2f13d7796">DB_PIN_0</a>);</div><div class="line"></div><div class="line">    <span class="keywordflow">while</span>(<span class="keyword">true</span>) {</div><div class="line">        <a class="code" href="km_debug_8h.html#a67f16e1067dd9d5aade7458fb706f504">dbToggle</a>(<a class="code" href="km_debug_8h.html#aa75c08c034edbf8e7d2ab7f4368ba1f3a68e15f535d372cae08798ca2f13d7796">DB_PIN_0</a>);</div><div class="line">        _delay_ms(500);</div><div class="line">    }</div><div class="line">}</div></div><!-- fragment --><p>References:</p><ul>
<li><a href="https://atnel2.blogspot.com/2014/04/puapki-programowe-debuger-na-jednej.html">https://atnel2.blogspot.com/2014/04/puapki-programowe-debuger-na-jednej.html</a> </li>
</ul>
</div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.15 </li>
  </ul>
</div>
</body>
</html>
